diff --git a/roms/ipxe/src/include/stdlib.h b/roms/ipxe/src/include/stdlib.h
index 19a7c8e09afb8e592ca6c67f074e..3d30858ffcd25e12b3b37da2b362 100644
--- a/roms/ipxe/src/include/stdlib.h
+++ b/roms/ipxe/src/include/stdlib.h
@@ -5,7 +5,6 @@ FILE_LICENCE ( GPL2_OR_LATER );
 
 #include <stdint.h>
 #include <assert.h>
-#include <ctype.h>
 
 /*****************************************************************************
  *
@@ -18,9 +17,6 @@ static inline int strtoul_base ( const char **pp, int base )
 {
 	const char *p = *pp;
 
-	while ( isspace ( *p ) )
-		p++;
-
 	if ( base == 0 ) {
 		base = 10;
 		if ( *p == '0' ) {
diff --git a/roms/ipxe/src/include/string.h b/roms/ipxe/src/include/string.h
index 2fd6acf1636e58f3bf54a70857e5..3482e1b2248c97fbcabe5431edeb 100644
--- a/roms/ipxe/src/include/string.h
+++ b/roms/ipxe/src/include/string.h
@@ -37,6 +37,7 @@ char * __pure strpbrk(const char * cs,const char * ct) __nonnull;
 char * strtok(char * s,const char * ct) __nonnull;
 char * strsep(char **s, const char *ct) __nonnull;
 void * memset(void * s,int c,size_t count) __nonnull;
+void * memcpy ( void *dest, const void *src, size_t len ) __nonnull;
 void * memmove(void * dest,const void *src,size_t count) __nonnull;
 int __pure memcmp(const void * cs,const void * ct,
 				    size_t count) __nonnull;
diff --git a/roms/ipxe/src/include/sys/time.h b/roms/ipxe/src/include/sys/time.h
index 21fb7e99d2d015b9ce82acf5b7f8..6c9b7421bbbd4d59fabcf8032d69 100644
--- a/roms/ipxe/src/include/sys/time.h
+++ b/roms/ipxe/src/include/sys/time.h
@@ -1,20 +1,18 @@
 #ifndef _SYS_TIME_H
 #define _SYS_TIME_H
 
-#include <time.h>
+/** @file
+ *
+ * Date and time
+ */
 
-typedef unsigned long suseconds_t;
+#include <stdint.h>
 
-struct timeval {
-	time_t tv_sec;		/* seconds */
-	suseconds_t tv_usec;	/* microseconds */
-};
-
-struct timezone {
-	int tz_minuteswest;	/* minutes W of Greenwich */
-	int tz_dsttime;		/* type of dst correction */
-};
-
-extern int gettimeofday ( struct timeval *tv, struct timezone *tz );
+/** Seconds since the Epoch
+ *
+ * We use a 64-bit type to avoid Y2K38 issues, since we may have to
+ * handle distant future dates (e.g. X.509 certificate expiry dates).
+ */
+typedef int64_t time_t;
 
 #endif /* _SYS_TIME_H */
diff --git a/roms/ipxe/src/include/syslog.h b/roms/ipxe/src/include/syslog.h
new file mode 100644
index 0000000000000000000000000000000000000000..93f32f8676d260f19d6878a73cd291ac69a440c3
--- /dev/null
+++ b/roms/ipxe/src/include/syslog.h
@@ -0,0 +1,100 @@
+#ifndef _SYSLOG_H
+#define _SYSLOG_H
+
+/** @file
+ *
+ * System logger
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdarg.h>
+#include <ipxe/ansiesc.h>
+#include <config/console.h>
+
+/**
+ * @defgroup syslogpri Syslog priorities
+ *
+ * These values are chosen to match those used in the syslog network
+ * protocol (RFC 5424).
+ *
+ * @{
+ */
+
+/** Emergency: system is unusable */
+#define LOG_EMERG 0
+
+/** Alert: action must be taken immediately */
+#define LOG_ALERT 1
+
+/** Critical: critical conditions */
+#define LOG_CRIT 2
+
+/** Error: error conditions */
+#define LOG_ERR 3
+
+/** Warning: warning conditions */
+#define LOG_WARNING 4
+
+/** Notice: normal but significant conditions */
+#define LOG_NOTICE 5
+
+/** Informational: informational messages */
+#define LOG_INFO 6
+
+/** Debug: debug-level messages */
+#define LOG_DEBUG 7
+
+/** @} */
+
+/** Do not log any messages */
+#define LOG_NONE -1
+
+/** Log all messages */
+#define LOG_ALL LOG_DEBUG
+
+extern void log_vprintf ( const char *fmt, va_list args );
+
+extern void __attribute__ (( format ( printf, 1, 2 ) ))
+log_printf ( const char *fmt, ... );
+
+/** ANSI private escape sequence to set syslog priority
+ *
+ * @v priority		Priority
+ */
+#define SYSLOG_SET_PRIORITY( priority ) \
+	"\033[" #priority "p"
+
+/** ANSI private escape sequence to clear syslog priority */
+#define SYSLOG_CLEAR_PRIORITY "\033[p"
+
+/**
+ * Write message to system log
+ *
+ * @v priority		Message priority
+ * @v fmt		Format string
+ * @v ...		Arguments
+ */
+#define vsyslog( priority, fmt, args ) do {				\
+	if ( (priority) <= LOG_LEVEL ) {				\
+		log_vprintf ( SYSLOG_SET_PRIORITY ( priority ) fmt	\
+			      SYSLOG_CLEAR_PRIORITY, (args) );		\
+	}								\
+	} while ( 0 )
+
+/**
+ * Write message to system log
+ *
+ * @v priority		Message priority
+ * @v fmt		Format string
+ * @v ...		Arguments
+ */
+#define syslog( priority, fmt, ... ) do {				\
+	if ( (priority) <= LOG_LEVEL ) {				\
+		log_printf ( SYSLOG_SET_PRIORITY ( priority ) fmt	\
+			     SYSLOG_CLEAR_PRIORITY, ##__VA_ARGS__ );	\
+	}								\
+	} while ( 0 )
+
+#endif /* _SYSLOG_H */
diff --git a/roms/ipxe/src/include/time.h b/roms/ipxe/src/include/time.h
index 6ea927c3250650560cdec4ae59b0..bc73af4cd25720742171a3cbe945 100644
--- a/roms/ipxe/src/include/time.h
+++ b/roms/ipxe/src/include/time.h
@@ -1,21 +1,50 @@
 #ifndef _TIME_H
 #define _TIME_H
 
-typedef unsigned long time_t;
+/** @file
+ *
+ * Date and time
+ */
 
+#include <sys/time.h>
+#include <ipxe/time.h>
+
+/** Broken-down time */
 struct tm {
-	int tm_sec;	/* seconds */
-	int tm_min;	/* minutes */
-	int tm_hour;	/* hours */
-	int tm_mday;	/* day of the month */
-	int tm_mon;	/* month */
-	int tm_year;	/* year */
-	int tm_wday;	/* day of the week */
-	int tm_yday;	/* day in the year */
-	int tm_isdst;	/* daylight saving time */
+	/** Seconds [0,60] */
+	int tm_sec;
+	/** Minutes [0,59] */
+	int tm_min;
+	/** Hour [0,23] */
+	int tm_hour;
+	/** Day of month [1,31] */
+	int tm_mday;
+	/** Month of year [0,11] */
+	int tm_mon;
+	/** Years since 1900 */
+	int tm_year;
+	/** Day of week [0,6] (Sunday=0) */
+	int tm_wday;
+	/** Day of year [0,365] */
+	int tm_yday;
+	/** Daylight savings flag */
+	int tm_isdst;
 };
 
-extern time_t time ( time_t *t );
+/**
+ * Get current time in seconds since the Epoch
+ *
+ * @v t			Time to fill in, or NULL
+ * @ret time		Current time
+ */
+static inline time_t time ( time_t *t ) {
+	time_t now;
+
+	now = time_now();
+	if ( t )
+		*t = now;
+	return now;
+}
 
 extern time_t mktime ( struct tm *tm );
 
diff --git a/roms/ipxe/src/include/usr/autoboot.h b/roms/ipxe/src/include/usr/autoboot.h
index a608b3dce7a850541f25317c69ba..cfa4c41eb290cba36486f9505216 100644
--- a/roms/ipxe/src/include/usr/autoboot.h
+++ b/roms/ipxe/src/include/usr/autoboot.h
@@ -14,11 +14,24 @@ struct net_device;
 struct uri;
 struct settings;
 
-extern int uriboot ( struct uri *filename, struct uri *root_path );
+/** uriboot() flags */
+enum uriboot_flags {
+	URIBOOT_NO_SAN_DESCRIBE = 0x0001,
+	URIBOOT_NO_SAN_BOOT = 0x0002,
+	URIBOOT_NO_SAN_UNHOOK = 0x0004,
+};
+
+#define URIBOOT_NO_SAN ( URIBOOT_NO_SAN_DESCRIBE | \
+			 URIBOOT_NO_SAN_BOOT |	   \
+			 URIBOOT_NO_SAN_UNHOOK )
+
+extern int uriboot ( struct uri *filename, struct uri *root_path, int drive,
+		     unsigned int flags );
 extern struct uri *
 fetch_next_server_and_filename ( struct settings *settings );
 extern int netboot ( struct net_device *netdev );
 extern int autoboot ( void );
+extern void ipxe ( struct net_device *netdev );
 
 extern int pxe_menu_boot ( struct net_device *netdev );
 
diff --git a/roms/ipxe/src/include/usr/imgmgmt.h b/roms/ipxe/src/include/usr/imgmgmt.h
index 1c0a212e3d030275c51e4b3ea7b2..8db5c9780f59c1ab6db569c8eb0d 100644
--- a/roms/ipxe/src/include/usr/imgmgmt.h
+++ b/roms/ipxe/src/include/usr/imgmgmt.h
@@ -11,46 +11,9 @@ FILE_LICENCE ( GPL2_OR_LATER );
 
 #include <ipxe/image.h>
 
-extern int register_and_put_image ( struct image *image );
-extern int register_and_probe_image ( struct image *image );
-extern int register_and_select_image ( struct image *image );
-extern int register_and_boot_image ( struct image *image );
-extern int register_and_replace_image ( struct image *image );
-extern int imgdownload ( struct uri *uri, const char *name, const char *cmdline,
-			 int ( * action ) ( struct image *image ) );
-extern int imgdownload_string ( const char *uri_string, const char *name,
-				const char *cmdline,
-				int ( * action ) ( struct image *image ) );
+extern int imgdownload ( struct uri *uri, struct image **image );
+extern int imgdownload_string ( const char *uri_string, struct image **image );
+extern int imgacquire ( const char *name, struct image **image );
 extern void imgstat ( struct image *image );
-extern void imgfree ( struct image *image );
-
-/**
- * Select an image for execution
- *
- * @v image		Image
- * @ret rc		Return status code
- */
-static inline int imgselect ( struct image *image ) {
-	return image_select ( image );
-}
-
-/**
- * Find the previously-selected image
- *
- * @ret image		Image, or NULL
- */
-static inline struct image * imgautoselect ( void ) {
-	return image_find_selected();
-}
-
-/**
- * Execute an image
- *
- * @v image		Image
- * @ret rc		Return status code
- */
-static inline int imgexec ( struct image *image ) {
-	return image_exec ( image );
-}
 
 #endif /* _USR_IMGMGMT_H */
diff --git a/roms/ipxe/src/include/usr/imgtrust.h b/roms/ipxe/src/include/usr/imgtrust.h
new file mode 100644
index 0000000000000000000000000000000000000000..f47105af0a5733af84c9adf45485bcd75033bd9b
--- /dev/null
+++ b/roms/ipxe/src/include/usr/imgtrust.h
@@ -0,0 +1,17 @@
+#ifndef _USR_IMGTRUST_H
+#define _USR_IMGTRUST_H
+
+/** @file
+ *
+ * Image trust management
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <ipxe/image.h>
+
+extern int imgverify ( struct image *image, struct image *signature,
+		       const char *name );
+
+#endif /* _USR_IMGTRUST_H */
diff --git a/roms/ipxe/src/include/usr/nslookup.h b/roms/ipxe/src/include/usr/nslookup.h
new file mode 100644
index 0000000000000000000000000000000000000000..d34649e9facffae0e3ca65903926c44380e5101d
--- /dev/null
+++ b/roms/ipxe/src/include/usr/nslookup.h
@@ -0,0 +1,14 @@
+#ifndef _USR_NSLOOKUP_H
+#define _USR_NSLOOKUP_H
+
+/** @file
+ *
+ * Standalone name resolution
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+extern int nslookup ( const char *name, const char *setting_name );
+
+#endif /* _USR_NSLOOKUP_H */
diff --git a/roms/ipxe/src/include/wchar.h b/roms/ipxe/src/include/wchar.h
new file mode 100644
index 0000000000000000000000000000000000000000..ba349aae8370b01fd634d8cf7e9c629888b9fac1
--- /dev/null
+++ b/roms/ipxe/src/include/wchar.h
@@ -0,0 +1,29 @@
+#ifndef WCHAR_H
+#define WCHAR_H
+
+FILE_LICENCE ( GPL2_ONLY );
+
+#include <stddef.h>
+
+typedef void mbstate_t;
+
+/**
+ * Convert wide character to multibyte sequence
+ *
+ * @v buf		Buffer
+ * @v wc		Wide character
+ * @v ps		Shift state
+ * @ret len		Number of characters written
+ *
+ * This is a stub implementation, sufficient to handle basic ASCII
+ * characters.
+ */
+static inline __attribute__ (( always_inline ))
+size_t wcrtomb ( char *buf, wchar_t wc, mbstate_t *ps __unused ) {
+	*buf = wc;
+	return 1;
+}
+
+extern size_t wcslen ( const wchar_t *string );
+
+#endif /* WCHAR_H */
diff --git a/roms/ipxe/src/interface/bofm/bofm.c b/roms/ipxe/src/interface/bofm/bofm.c
index dfa76d3252cd7bf656d078e33c0e..b0e92b27cec09d2653a9afc6b5bd 100644
--- a/roms/ipxe/src/interface/bofm/bofm.c
+++ b/roms/ipxe/src/interface/bofm/bofm.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -181,14 +182,14 @@ static int bofm_en ( struct bofm_device *bofm, struct bofm_en *en ) {
 
 	/* Retrieve current MAC address */
 	if ( ( rc = bofm->op->harvest ( bofm, en->mport, mac ) ) != 0 ) {
-		DBG ( "BOFM: " PCI_FMT " port %d could not harvest: %s\n",
+		DBG ( "BOFM: " PCI_FMT " mport %d could not harvest: %s\n",
 		      PCI_ARGS ( bofm->pci ), en->mport, strerror ( rc ) );
 		return rc;
 	}
 
 	/* Harvest MAC address if necessary */
 	if ( en->options & BOFM_EN_RQ_HVST_MASK ) {
-		DBG ( "BOFM: " PCI_FMT " port %d harvested MAC %s\n",
+		DBG ( "BOFM: " PCI_FMT " mport %d harvested MAC %s\n",
 		      PCI_ARGS ( bofm->pci ), en->mport, eth_ntoa ( mac ) );
 		memcpy ( en->mac_a, mac, sizeof ( en->mac_a ) );
 		en->options |= ( BOFM_EN_EN_A | BOFM_EN_HVST );
@@ -197,7 +198,7 @@ static int bofm_en ( struct bofm_device *bofm, struct bofm_en *en ) {
 	/* Mark as changed if necessary */
 	if ( ( en->options & BOFM_EN_EN_A ) &&
 	     ( memcmp ( en->mac_a, mac, sizeof ( en->mac_a ) ) != 0 ) ) {
-		DBG ( "BOFM: " PCI_FMT " port %d MAC %s",
+		DBG ( "BOFM: " PCI_FMT " mport %d MAC %s",
 		      PCI_ARGS ( bofm->pci ), en->mport, eth_ntoa ( mac ) );
 		DBG ( " changed to %s\n", eth_ntoa ( en->mac_a ) );
 		en->options |= BOFM_EN_CHG_CHANGED;
@@ -207,7 +208,7 @@ static int bofm_en ( struct bofm_device *bofm, struct bofm_en *en ) {
 	if ( ( en->options & BOFM_EN_EN_A ) &&
 	     ( en->options & BOFM_EN_USAGE_ENTRY ) &&
 	     ( ! ( en->options & BOFM_EN_USAGE_HARVEST ) ) ) {
-		DBG ( "BOFM: " PCI_FMT " port %d applied MAC %s\n",
+		DBG ( "BOFM: " PCI_FMT " mport %d applied MAC %s\n",
 		      PCI_ARGS ( bofm->pci ), en->mport,
 		      eth_ntoa ( en->mac_a ) );
 		memcpy ( mac, en->mac_a, sizeof ( mac ) );
@@ -215,7 +216,7 @@ static int bofm_en ( struct bofm_device *bofm, struct bofm_en *en ) {
 
 	/* Store MAC address */
 	if ( ( rc = bofm->op->update ( bofm, en->mport, mac ) ) != 0 ) {
-		DBG ( "BOFM: " PCI_FMT " port %d could not update: %s\n",
+		DBG ( "BOFM: " PCI_FMT " mport %d could not update: %s\n",
 		      PCI_ARGS ( bofm->pci ), en->mport, strerror ( rc ) );
 		return rc;
 	}
@@ -303,14 +304,19 @@ int bofm ( userptr_t bofmtab, struct pci_device *pci ) {
 		DBG2_HDA ( en_offset, &en, sizeof ( en ) );
 		if ( ( en.options & BOFM_EN_MAP_MASK ) != BOFM_EN_MAP_PFA ) {
 			DBG ( "BOFM: slot %d port %d has no PCI mapping\n",
-			      en.slot, en.port );
+			      en.slot, ( en.port + 1 ) );
 			continue;
 		}
+		DBG ( "BOFM: slot %d port %d%s is " PCI_FMT " mport %d\n",
+		      en.slot, ( en.port + 1 ),
+		      ( ( en.slot || en.port ) ? "" : "(?)" ),
+		      PCI_BUS ( en.busdevfn ), PCI_SLOT ( en.busdevfn ),
+		      PCI_FUNC ( en.busdevfn ), en.mport );
 		bofm = bofm_find_busdevfn ( en.busdevfn );
 		if ( ! bofm ) {
-			DBG ( "BOFM: " PCI_FMT " ignored\n",
+			DBG ( "BOFM: " PCI_FMT " mport %d ignored\n",
 			      PCI_BUS ( en.busdevfn ), PCI_SLOT ( en.busdevfn ),
-			      PCI_FUNC ( en.busdevfn ) );
+			      PCI_FUNC ( en.busdevfn ), en.mport );
 			continue;
 		}
 		if ( ( rc = bofm_en ( bofm, &en ) ) == 0 ) {
diff --git a/roms/ipxe/src/interface/efi/efi_bofm.c b/roms/ipxe/src/interface/efi/efi_bofm.c
index 1d647db4378afb27a543a8c65ea0..c313d2e97ab439313fb5fbed93c2 100644
--- a/roms/ipxe/src/interface/efi/efi_bofm.c
+++ b/roms/ipxe/src/interface/efi/efi_bofm.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -97,6 +98,9 @@ typedef struct {
 typedef struct _IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL
 	IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL;
 
+typedef struct _IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2
+	IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2;
+
 typedef EFI_STATUS ( EFIAPI *IBM_BOFM_DRIVER_CONFIGURATION_SUPPORT ) (
 	IN IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL *This,
 	EFI_HANDLE ControllerHandle,
@@ -112,20 +116,27 @@ typedef EFI_STATUS ( EFIAPI *IBM_BOFM_DRIVER_CONFIGURATION_STATUS ) (
 	UINT8 BOFMReturnCode
 );
 
+typedef EFI_STATUS ( EFIAPI *IBM_BOFM_DRIVER_CONFIGURATION_STATUS2 ) (
+	IN IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2 *This,
+	EFI_HANDLE ControllerHandle,
+	BOOLEAN ResetRequired,
+	UINT8 BOFMReturnCode
+);
+
 struct _IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL {
 	IBM_BOFM_TABLE BofmTable;
 	IBM_BOFM_DRIVER_CONFIGURATION_STATUS SetStatus;
 	IBM_BOFM_DRIVER_CONFIGURATION_SUPPORT RegisterSupport;
 };
 
-typedef struct _IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2 {
+struct _IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2 {
 	UINT32 Signature;
 	UINT32 Reserved1;
 	UINT64 Reserved2;
-	IBM_BOFM_DRIVER_CONFIGURATION_STATUS SetStatus;
+	IBM_BOFM_DRIVER_CONFIGURATION_STATUS2 SetStatus;
 	IBM_BOFM_DRIVER_CONFIGURATION_SUPPORT RegisterSupport;
 	IBM_BOFM_TABLE BofmTable;
-} IBM_BOFM_DRIVER_CONFIGURATION_PROTOCOL2;
+};
 
 /***************************************************************************
  *
@@ -165,7 +176,7 @@ efi_bofm_supported ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 	EFI_STATUS efirc;
 	int rc;
 
-	DBGCP ( efidrv, "BOFM DRIVER_SUPPORTED %p (%p)\n", device, child );
+	DBGCP ( efidrv, "EFIBOFM DRIVER_SUPPORTED %p (%p)\n", device, child );
 
 	/* Create corresponding PCI device, if any */
 	efipci = efipci_create ( efidrv, device );
@@ -176,7 +187,7 @@ efi_bofm_supported ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 
 	/* Look for a BOFM driver */
 	if ( ( rc = bofm_find_driver ( &efipci->pci ) ) != 0 ) {
-		DBGC2 ( efidrv, "BOFM " PCI_FMT " has no driver\n",
+		DBGCP ( efidrv, "EFIBOFM " PCI_FMT " has no driver\n",
 			PCI_ARGS ( &efipci->pci ) );
 		efirc = EFI_UNSUPPORTED;
 		goto err_no_driver;
@@ -185,8 +196,8 @@ efi_bofm_supported ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 	/* Locate BOFM protocol */
 	if ( ( efirc = bs->LocateProtocol ( &bofm1_protocol_guid, NULL,
 					    &bofm1.interface ) ) != 0 ) {
-		DBGC ( efidrv, "BOFM " PCI_FMT " cannot find BOFM protocol\n",
-		       PCI_ARGS ( &efipci->pci ) );
+		DBGC ( efidrv, "EFIBOFM " PCI_FMT " cannot find BOFM "
+		       "protocol\n", PCI_ARGS ( &efipci->pci ) );
 		efirc = EFI_UNSUPPORTED;
 		goto err_not_bofm;
 	}
@@ -196,13 +207,13 @@ efi_bofm_supported ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 						      0x04 /* Can change MAC */,
 						      0x00 /* No iSCSI */,
 						      0x02 /* Version */ ))!=0){
-		DBGC ( efidrv, "BOFM " PCI_FMT " could not register support: "
-		       "%s\n", PCI_ARGS ( &efipci->pci ),
+		DBGC ( efidrv, "EFIBOFM " PCI_FMT " could not register "
+		       "support: %s\n", PCI_ARGS ( &efipci->pci ),
 		       efi_strerror ( efirc ) );
 		goto err_cannot_register;
 	}
 
-	DBGC ( efidrv, "BOFM " PCI_FMT " is supported by driver \"%s\"\n",
+	DBGC ( efidrv, "EFIBOFM " PCI_FMT " is supported by driver \"%s\"\n",
 	       PCI_ARGS ( &efipci->pci ), efipci->pci.id->name );
 
 	/* Destroy temporary PCI device */
@@ -241,11 +252,12 @@ static EFI_STATUS EFIAPI efi_bofm_start ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 		void *interface;
 	} bofm2;
 	struct efi_pci_device *efipci;
-	userptr_t bofmtab;
+	IBM_BOFM_TABLE *bofmtab;
+	IBM_BOFM_TABLE *bofmtab2;
 	EFI_STATUS efirc;
 	int bofmrc;
 
-	DBGCP ( efidrv, "BOFM DRIVER_START %p (%p)\n", device, child );
+	DBGCP ( efidrv, "EFIBOFM DRIVER_START %p (%p)\n", device, child );
 
 	/* Create corresponding PCI device */
 	efipci = efipci_create ( efidrv, device );
@@ -261,46 +273,70 @@ static EFI_STATUS EFIAPI efi_bofm_start ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 	/* Locate BOFM protocol */
 	if ( ( efirc = bs->LocateProtocol ( &bofm1_protocol_guid, NULL,
 					    &bofm1.interface ) ) != 0 ) {
-		DBGC ( efidrv, "BOFM " PCI_FMT " cannot find BOFM protocol\n",
-		       PCI_ARGS ( &efipci->pci ) );
+		DBGC ( efidrv, "EFIBOFM " PCI_FMT " cannot find BOFM "
+		       "protocol\n", PCI_ARGS ( &efipci->pci ) );
 		goto err_locate_bofm;
 	}
+	bofmtab = &bofm1.bofm1->BofmTable;
+	DBGC ( efidrv, "EFIBOFM " PCI_FMT " found version 1 BOFM table at "
+	       "%p+%04x\n", PCI_ARGS ( &efipci->pci ), bofmtab,
+	       bofmtab->Parameters.Length );
 
 	/* Locate BOFM2 protocol, if available */
 	if ( ( efirc = bs->LocateProtocol ( &bofm2_protocol_guid, NULL,
-					    &bofm2.interface ) ) != 0 ) {
-		DBGC ( efidrv, "BOFM " PCI_FMT " cannot find BOFM2 protocol\n",
-		       PCI_ARGS ( &efipci->pci ) );
-		/* Not a fatal error; may be a BOFM1-only system */
-		bofm2.bofm2 = NULL;
-	}
-
-	/* Select appropriate BOFM table (v1 or v2) to use */
-	if ( bofm2.bofm2 ) {
-		DBGC ( efidrv, "BOFM " PCI_FMT " using version 2 BOFM table\n",
-		       PCI_ARGS ( &efipci->pci ) );
+					    &bofm2.interface ) ) == 0 ) {
+		bofmtab2 = &bofm2.bofm2->BofmTable;
+		DBGC ( efidrv, "EFIBOFM " PCI_FMT " found version 2 BOFM table "
+		       "at %p+%04x\n", PCI_ARGS ( &efipci->pci ), bofmtab2,
+		       bofmtab2->Parameters.Length );
 		assert ( bofm2.bofm2->RegisterSupport ==
 			 bofm1.bofm1->RegisterSupport );
-		assert ( bofm2.bofm2->SetStatus == bofm1.bofm1->SetStatus );
-		bofmtab = virt_to_user ( &bofm2.bofm2->BofmTable );
 	} else {
-		DBGC ( efidrv, "BOFM " PCI_FMT " using version 1 BOFM table\n",
-		       PCI_ARGS ( &efipci->pci ) );
-		bofmtab = virt_to_user ( &bofm1.bofm1->BofmTable );
+		DBGC ( efidrv, "EFIBOFM " PCI_FMT " cannot find BOFM2 "
+		       "protocol\n", PCI_ARGS ( &efipci->pci ) );
+		/* Not a fatal error; may be a BOFM1-only system */
+		bofmtab2 = NULL;
 	}
 
 	/* Process BOFM table */
-	bofmrc = bofm ( bofmtab, &efipci->pci );
-	DBGC ( efidrv, "BOFM " PCI_FMT " status %08x\n",
+	DBGC2 ( efidrv, "EFIBOFM " PCI_FMT " version 1 before processing:\n",
+		PCI_ARGS ( &efipci->pci ) );
+	DBGC2_HD ( efidrv, bofmtab, bofmtab->Parameters.Length );
+	if ( bofmtab2 ) {
+		DBGC2 ( efidrv, "EFIBOFM " PCI_FMT " version 2 before "
+			"processing:\n", PCI_ARGS ( &efipci->pci ) );
+		DBGC2_HD ( efidrv, bofmtab2, bofmtab2->Parameters.Length );
+	}
+	bofmrc = bofm ( virt_to_user ( bofmtab2 ? bofmtab2 : bofmtab ),
+			&efipci->pci );
+	DBGC ( efidrv, "EFIBOFM " PCI_FMT " status %08x\n",
 	       PCI_ARGS ( &efipci->pci ), bofmrc );
+	DBGC2 ( efidrv, "EFIBOFM " PCI_FMT " version 1 after processing:\n",
+		PCI_ARGS ( &efipci->pci ) );
+	DBGC2_HD ( efidrv, bofmtab, bofmtab->Parameters.Length );
+	if ( bofmtab2 ) {
+		DBGC2 ( efidrv, "EFIBOFM " PCI_FMT " version 2 after "
+			"processing:\n", PCI_ARGS ( &efipci->pci ) );
+		DBGC2_HD ( efidrv, bofmtab2, bofmtab2->Parameters.Length );
+	}
 
 	/* Return BOFM status */
-	if ( ( efirc = bofm1.bofm1->SetStatus ( bofm1.bofm1, device, FALSE,
-						bofmrc ) ) != 0 ) {
-		DBGC ( efidrv, "BOFM " PCI_FMT " could not set BOFM status: "
-		       "%s\n", PCI_ARGS ( &efipci->pci ),
-		       efi_strerror ( efirc ) );
-		goto err_set_status;
+	if ( bofmtab2 ) {
+		if ( ( efirc = bofm2.bofm2->SetStatus ( bofm2.bofm2, device,
+							FALSE, bofmrc ) ) != 0){
+			DBGC ( efidrv, "EFIBOFM " PCI_FMT " could not set "
+			       "BOFM2 status: %s\n", PCI_ARGS ( &efipci->pci ),
+			       efi_strerror ( efirc ) );
+			goto err_set_status;
+		}
+	} else {
+		if ( ( efirc = bofm1.bofm1->SetStatus ( bofm1.bofm1, device,
+							FALSE, bofmrc ) ) != 0){
+			DBGC ( efidrv, "EFIBOFM " PCI_FMT " could not set "
+			       "BOFM status: %s\n", PCI_ARGS ( &efipci->pci ),
+			       efi_strerror ( efirc ) );
+			goto err_set_status;
+		}
 	}
 
 	/* Destroy the PCI device anyway; we have no further use for it */
@@ -332,7 +368,7 @@ static EFI_STATUS EFIAPI efi_bofm_stop ( EFI_DRIVER_BINDING_PROTOCOL *driver,
 	struct efi_driver *efidrv =
 		container_of ( driver, struct efi_driver, driver );
 
-	DBGCP ( efidrv, "BOFM DRIVER_STOP %p (%ld %p)\n",
+	DBGCP ( efidrv, "EFIBOFM DRIVER_STOP %p (%ld %p)\n",
 		device, ( ( unsigned long ) num_children ), children );
 
 	return 0;
@@ -353,12 +389,12 @@ static void efi_bofm_driver_init ( void ) {
 
 	/* Install driver */
 	if ( ( efirc = efi_driver_install ( efidrv ) ) != 0 ) {
-		DBGC ( efidrv, "BOFM could not install driver: %s\n",
+		DBGC ( efidrv, "EFIBOFM could not install driver: %s\n",
 		       efi_strerror ( efirc ) );
 		return;
 	}
 
-	DBGC ( efidrv, "BOFM driver installed\n" );
+	DBGC ( efidrv, "EFIBOFM driver installed\n" );
 }
 
 /** EFI BOFM startup function */
diff --git a/roms/ipxe/src/interface/efi/efi_console.c b/roms/ipxe/src/interface/efi/efi_console.c
index 1303a4278821f90eb77e921d7ecb..a30ca301b85d76927912635b317f 100644
--- a/roms/ipxe/src/interface/efi/efi_console.c
+++ b/roms/ipxe/src/interface/efi/efi_console.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -23,6 +24,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <ipxe/efi/efi.h>
 #include <ipxe/ansiesc.h>
 #include <ipxe/console.h>
+#include <config/console.h>
 
 #define ATTR_BOLD		0x08
 
@@ -48,6 +50,12 @@ FILE_LICENCE ( GPL2_OR_LATER );
 
 #define ATTR_DEFAULT		ATTR_FCOL_WHITE
 
+/* Set default console usage if applicable */
+#if ! ( defined ( CONSOLE_EFI ) && CONSOLE_EXPLICIT ( CONSOLE_EFI ) )
+#undef CONSOLE_EFI
+#define CONSOLE_EFI ( CONSOLE_USAGE_ALL & ~CONSOLE_USAGE_LOG )
+#endif
+
 /** Current character attribute */
 static unsigned int efi_attr = ATTR_DEFAULT;
 
@@ -273,4 +281,5 @@ struct console_driver efi_console __console_driver = {
 	.putchar = efi_putchar,
 	.getchar = efi_getchar,
 	.iskey = efi_iskey,
+	.usage = CONSOLE_EFI,
 };
diff --git a/roms/ipxe/src/interface/efi/efi_debug.c b/roms/ipxe/src/interface/efi/efi_debug.c
new file mode 100644
index 0000000000000000000000000000000000000000..a7ba7e2edd4f2ede8324d87a74fe8a2aadac6c5e
--- /dev/null
+++ b/roms/ipxe/src/interface/efi/efi_debug.c
@@ -0,0 +1,114 @@
+/*
+ * Copyright (C) 2013 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/**
+ * @file
+ *
+ * EFI debugging utilities
+ *
+ */
+
+#include <stdio.h>
+#include <string.h>
+#include <ipxe/uuid.h>
+#include <ipxe/efi/efi.h>
+#include <ipxe/efi/efi_driver.h>
+#include <ipxe/efi/Protocol/DevicePath.h>
+#include <ipxe/efi/Protocol/DevicePathToText.h>
+
+/** Device path to text protocol */
+static EFI_DEVICE_PATH_TO_TEXT_PROTOCOL *efidpt;
+EFI_REQUIRE_PROTOCOL ( EFI_DEVICE_PATH_TO_TEXT_PROTOCOL, &efidpt );
+
+/**
+ * Convert GUID to a printable string
+ *
+ * @v guid		GUID
+ * @ret string		Printable string
+ */
+const char * efi_guid_ntoa ( EFI_GUID *guid ) {
+	union {
+		union uuid uuid;
+		EFI_GUID guid;
+	} u;
+
+	/* Convert GUID to standard endianness */
+	memcpy ( &u.guid, guid, sizeof ( u.guid ) );
+	uuid_mangle ( &u.uuid );
+	return uuid_ntoa ( &u.uuid );
+}
+
+/**
+ * Print list of protocol handlers attached to a handle
+ *
+ * @v handle		EFI handle
+ */
+void dbg_efi_protocols ( EFI_HANDLE handle ) {
+	EFI_BOOT_SERVICES *bs = efi_systab->BootServices;
+        EFI_GUID **protocols;
+	UINTN count;
+	unsigned int i;
+	EFI_STATUS efirc;
+
+	/* Retrieve list of protocols */
+	if ( ( efirc = bs->ProtocolsPerHandle ( handle, &protocols,
+						&count ) ) != 0 ) {
+		printf ( "EFI could not retrieve protocols for %p: %s\n",
+			 handle, efi_strerror ( efirc ) );
+		return;
+	}
+
+	/* Dump list of protocols */
+	for ( i = 0 ; i < count ; i++ )
+		printf ( "%s\n", efi_guid_ntoa ( protocols[i] ) );
+
+	/* Free list */
+	bs->FreePool ( protocols );
+}
+
+/**
+ * Print device path
+ *
+ * @v path		Device path
+ */
+void dbg_efi_devpath ( EFI_DEVICE_PATH_PROTOCOL *path ) {
+	EFI_BOOT_SERVICES *bs = efi_systab->BootServices;
+	EFI_DEVICE_PATH_PROTOCOL *end;
+	CHAR16 *text;
+	size_t len;
+
+	/* Convert path to a textual representation */
+	text = efidpt->ConvertDevicePathToText ( path, TRUE, FALSE );
+	if ( ! text ) {
+		printf ( "<cannot convert>:\n" );
+		end = efi_devpath_end ( path );
+		len = ( ( ( void * ) end ) - ( ( void * ) path ) +
+			sizeof ( *end ) );
+		dbg_hex_dump_da ( 0, path, len );
+		return;
+	}
+
+	/* Print path */
+	printf ( "%ls", text );
+
+	/* Free path */
+	bs->FreePool ( text );
+}
